'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var PropTypes = _interopRequireWildcard(_propTypes);

var _relayRuntime = require('relay-runtime');

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ReleasyConsumer = function (_React$PureComponent) {
  _inherits(ReleasyConsumer, _React$PureComponent);

  function ReleasyConsumer(props) {
    _classCallCheck(this, ReleasyConsumer);

    (0, _invariant2.default)(props.children, 'ReleasyConsumer: missing "children"');

    return _possibleConstructorReturn(this, (ReleasyConsumer.__proto__ || Object.getPrototypeOf(ReleasyConsumer)).call(this, props));
  }

  _createClass(ReleasyConsumer, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var children = this.props.children;


      return React.Children.map(children, function (child) {
        return React.cloneElement(child, { environment: _this2.context.environment });
      });
    }
  }]);

  return ReleasyConsumer;
}(React.PureComponent);

ReleasyConsumer.propTypes = {
  children: PropTypes.element.isRequired
};
ReleasyConsumer.contextTypes = {
  environment: PropTypes.instanceOf(_relayRuntime.Environment).isRequired
};
exports.default = ReleasyConsumer;