'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _RelayQueryResponseCache = require('relay-runtime/lib/RelayQueryResponseCache.js');

var _RelayQueryResponseCache2 = _interopRequireDefault(_RelayQueryResponseCache);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var InMemoryCache = function InMemoryCache(props) {
  var _this = this;

  _classCallCheck(this, InMemoryCache);

  this.get = function (queryID, variables) {
    return _this.store.get(queryID, variables);
  };

  this.set = function (queryID, variables, payload) {
    _this.store.set(queryID, variables, payload);
  };

  this.clear = function () {
    _this.store.clear();
  };

  this.store = new _RelayQueryResponseCache2.default({
    size: props && props.size ? props.size : 250,
    ttl: props && props.ttl ? props.ttl : 60 * 1000 * 5 // default = 5 minutes
  });
};

exports.default = InMemoryCache;