'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _relayDevtools = require('relay-devtools');

var _relayRuntime = require('relay-runtime');

var _RelayNetworkLogger = require('relay-runtime/lib/RelayNetworkLogger');

var _RelayNetworkLogger2 = _interopRequireDefault(_RelayNetworkLogger);

var _fetchQuery = require('../utils/fetchQuery');

var _fetchQuery2 = _interopRequireDefault(_fetchQuery);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createEnvironment = function createEnvironment(config) {
  if (config.devTools) {
    (0, _relayDevtools.installRelayDevTools)();
  }

  var network = _relayRuntime.Network.create(config.networkLogger ? _RelayNetworkLogger2.default.wrapFetch(_fetchQuery2.default) : _fetchQuery2.default);

  var source = new _relayRuntime.RecordSource();
  var store = new _relayRuntime.Store(source);

  return new _relayRuntime.Environment({
    network: network,
    store: store
  });
};

exports.default = createEnvironment;