'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _fetchWithRetries = require('fbjs/lib/fetchWithRetries');

var _fetchWithRetries2 = _interopRequireDefault(_fetchWithRetries);

var _getHeaders = require('./getHeaders');

var _getHeaders2 = _interopRequireDefault(_getHeaders);

var _getRequestBody = require('./getRequestBody');

var _getRequestBody2 = _interopRequireDefault(_getRequestBody);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Fetch = function () {
  function Fetch(props) {
    _classCallCheck(this, Fetch);

    (0, _invariant2.default)(props, 'Fetch: missing props');
    (0, _invariant2.default)(props.url, 'Fetch: missing "url"');

    this.url = props.url;
    this.headers = props.headers || {};
    this.fetchTimeout = props.fetchTimeout || 30000;
    this.retryDelays = props.retryDelays || [1000, 3000, 5000, 10000];
  }

  _createClass(Fetch, [{
    key: 'fetch',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(request, variables, cacheConfig, uploadables) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt('return', (0, _fetchWithRetries2.default)(this.url, {
                  method: 'POST',
                  fetchTimeout: this.fetchTimeout,
                  retryDelays: this.retryDelays,
                  headers: _extends({}, (0, _getHeaders2.default)(uploadables), this.headers),
                  body: (0, _getRequestBody2.default)(request, variables, uploadables)
                }));

              case 1:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function fetch(_x, _x2, _x3, _x4) {
        return _ref.apply(this, arguments);
      }

      return fetch;
    }()
  }]);

  return Fetch;
}();

exports.default = Fetch;