'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});


var getRequestBodyWithUploadables = function getRequestBodyWithUploadables(request, variables, uploadables) {
  var formData = new FormData();
  formData.append('query', request.text);
  formData.append('variables', JSON.stringify(variables));

  uploadables.forEach(function (uploadable, key) {
    // $FlowIgnore
    formData.append('image' + key, {
      name: uploadable.filename || 'image' + key + '.jpg',
      type: uploadable.mime || 'image/jpg',
      uri: uploadable.path
    });
  });

  return formData;
};


var getRequestBodyWithoutUplodables = function getRequestBodyWithoutUplodables(request, variables) {
  return JSON.stringify({
    query: request.text,
    variables: variables
  });
};

var getRequestBody = function getRequestBody(request, variables, uploadables) {
  if (uploadables) {
    return getRequestBodyWithUploadables({
      request: request,
      variables: variables,
      uploadables: uploadables
    });
  }

  return getRequestBodyWithoutUplodables(request, variables);
};

exports.default = getRequestBody;