'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _relayDevtools = require('relay-devtools');

var _relayRuntime = require('relay-runtime');

var _createNetwork = require('./createNetwork');

var _createNetwork2 = _interopRequireDefault(_createNetwork);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createEnvironment = function createEnvironment(config) {
  if (config.devTools) {
    (0, _relayDevtools.installRelayDevTools)();
  }

  var network = (0, _createNetwork2.default)(config);

  var source = new _relayRuntime.RecordSource();
  var store = new _relayRuntime.Store(source);

  return new _relayRuntime.Environment({
    network: network,
    store: store
  });
};
exports.default = createEnvironment;