'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _relayRuntime = require('relay-runtime');

var _RelayNetworkLogger = require('relay-runtime/lib/RelayNetworkLogger');

var _RelayNetworkLogger2 = _interopRequireDefault(_RelayNetworkLogger);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var createNetwork = function createNetwork(config) {
  var fetchFn = config.networkLogger ? _RelayNetworkLogger2.default.wrapFetch(config.link.fetch) : config.link.fetch;

  return _relayRuntime.Network.create(function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(request, variables, cacheConfig, uploadables) {
      var queryID, fromCache, fromServer;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              queryID = request.text;

              // no cache configured, just fetch the data from server

              if (config.cache) {
                _context.next = 3;
                break;
              }

              return _context.abrupt('return', fetchFn(request, variables, cacheConfig, uploadables));

            case 3:
              if (!(0, _utils.isMutation)(request)) {
                _context.next = 6;
                break;
              }

              config.cache.clear();
              return _context.abrupt('return', fetchFn(request, variables, cacheConfig, uploadables));

            case 6:

              // verify if data exists on cache
              fromCache = config.cache.get(queryID, variables);

              if (!(fromCache !== null && !(0, _utils.mustForceFetch)(cacheConfig))) {
                _context.next = 9;
                break;
              }

              return _context.abrupt('return', fromCache);

            case 9:
              _context.next = 11;
              return fetchFn(request, variables, cacheConfig, uploadables);

            case 11:
              fromServer = _context.sent;

              if (fromServer) {
                config.cache.set(queryID, variables, fromServer);
              }

              return _context.abrupt('return', fromServer);

            case 14:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    return function (_x, _x2, _x3, _x4) {
      return _ref.apply(this, arguments);
    };
  }());
};

exports.default = createNetwork;